diff -Naur -x '*.dia' -x '*.pcap' ns-3.31/src/core/test/random-variable-stream-test-suite.cc ns-3.32/src/core/test/random-variable-stream-test-suite.cc
--- ns-3.31/src/core/test/random-variable-stream-test-suite.cc	2020-06-27 17:38:30.000000000 -0700
+++ ns-3.32/src/core/test/random-variable-stream-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
@@ -719,121 +787,78 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // normally distributed random variable is equal to mean.
   double expectedMean = mean;
+  double expectedRms  = mean / std::sqrt (variance * N_MEASUREMENTS);
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedRms * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for exponential distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamExponentialTestCase : public TestCase
+/**
+ * Test case for exponential distribution random variable stream generator
+ */
+class ExponentialTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+  // Constructor
+  ExponentialTestCase ();
 
-  RandomVariableStreamExponentialTestCase ();
-  virtual ~RandomVariableStreamExponentialTestCase ();
-
-  double ChiSquaredTest (Ptr<ExponentialRandomVariable> e);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamExponentialTestCase::RandomVariableStreamExponentialTestCase ()
-  : TestCase ("Exponential Random Variable Stream Generator")
-{}
+  /** Tolerance for testing rng values against expectation, in rms. */
+  static constexpr double TOLERANCE {5};  
+};
 
-RandomVariableStreamExponentialTestCase::~RandomVariableStreamExponentialTestCase ()
+ExponentialTestCase::ExponentialTestCase ()
+  : TestCaseBase ("Exponential Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamExponentialTestCase::ChiSquaredTest (Ptr<ExponentialRandomVariable> e)
+ExponentialTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that e has mean equal to one, which is the
   // default value for this distribution.
   double mu = 1.;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_exponential_P (range[i + 1], mu) - gsl_cdf_exponential_P (range[i], mu);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, e->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamExponentialTestCase::DoRun (void)
+ExponentialTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<ExponentialRandomVariable> ();
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<ExponentialRandomVariable> e = CreateObject<ExponentialRandomVariable> ();
-      double result = ChiSquaredTest (e);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double mean = 3.14;
   double bound = 0.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ExponentialRandomVariable> x = CreateObject<ExponentialRandomVariable> ();
@@ -841,121 +866,75 @@
   x->SetAttribute ("Bound", DoubleValue (bound));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
+  double expectedMean = mean;
+  double expectedRms  = std::sqrt (mean / N_MEASUREMENTS);
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = mean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, mean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedRms * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic exponential distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamExponentialAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic exponential distribution random variable stream generator
+ */
+class ExponentialAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamExponentialAntitheticTestCase ();
-  virtual ~RandomVariableStreamExponentialAntitheticTestCase ();
+  // Constructor
+  ExponentialAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<ExponentialRandomVariable> e);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamExponentialAntitheticTestCase::RandomVariableStreamExponentialAntitheticTestCase ()
-  : TestCase ("Antithetic Exponential Random Variable Stream Generator")
-{}
+  /** Tolerance for testing rng values against expectation, in rms. */
+  static constexpr double TOLERANCE {5};
+};
 
-RandomVariableStreamExponentialAntitheticTestCase::~RandomVariableStreamExponentialAntitheticTestCase ()
+ExponentialAntitheticTestCase::ExponentialAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Exponential Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamExponentialAntitheticTestCase::ChiSquaredTest (Ptr<ExponentialRandomVariable> e)
+ExponentialAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that e has mean equal to one, which is the
   // default value for this distribution.
   double mu = 1.;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_exponential_P (range[i + 1], mu) - gsl_cdf_exponential_P (range[i], mu);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, e->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamExponentialAntitheticTestCase::DoRun (void)
+ExponentialAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<ExponentialRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<ExponentialRandomVariable> e = CreateObject<ExponentialRandomVariable> ();
-
-      // Make this generate antithetic values.
-      e->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (e);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double mean = 3.14;
   double bound = 0.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ExponentialRandomVariable> x = CreateObject<ExponentialRandomVariable> ();
@@ -966,116 +945,77 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
+  double expectedMean = mean;
+  double expectedRms  = std::sqrt (mean / N_MEASUREMENTS);
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = mean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, mean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedRms * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for Pareto distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamParetoTestCase : public TestCase
+/**
+ * Test case for Pareto distribution random variable stream generator
+ */
+class ParetoTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamParetoTestCase ();
-  virtual ~RandomVariableStreamParetoTestCase ();
+  // Constructor
+  ParetoTestCase ();
 
-  double ChiSquaredTest (Ptr<ParetoRandomVariable> p);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamParetoTestCase::RandomVariableStreamParetoTestCase ()
-  : TestCase ("Pareto Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamParetoTestCase::~RandomVariableStreamParetoTestCase ()
+ParetoTestCase::ParetoTestCase ()
+  : TestCaseBase ("Pareto Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamParetoTestCase::ChiSquaredTest (Ptr<ParetoRandomVariable> p)
+ParetoTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 1, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 1., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   double shape = 2.0;
   double scale = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_pareto_P (range[i + 1], shape, scale) - gsl_cdf_pareto_P (range[i], shape, scale);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, p->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamParetoTestCase::DoRun (void)
+ParetoTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<ParetoRandomVariable> ();
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<ParetoRandomVariable> e = CreateObject<ParetoRandomVariable> ();
-      double result = ChiSquaredTest (e);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double shape = 2.0;
   double scale = 1.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ParetoRandomVariable> x = CreateObject<ParetoRandomVariable> ();
@@ -1083,13 +1023,7 @@
   x->SetAttribute ("Scale", DoubleValue (scale));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean is given by
   //
@@ -1103,111 +1037,72 @@
   double expectedMean = (shape * scale) / (shape - 1.0);
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic Pareto distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamParetoAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic Pareto distribution random variable stream generator
+ */
+class ParetoAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamParetoAntitheticTestCase ();
-  virtual ~RandomVariableStreamParetoAntitheticTestCase ();
+  // Constructor
+  ParetoAntitheticTestCase ();
 
-  double ChiSquaredTest (Ptr<ParetoRandomVariable> p);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamParetoAntitheticTestCase::RandomVariableStreamParetoAntitheticTestCase ()
-  : TestCase ("Antithetic Pareto Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamParetoAntitheticTestCase::~RandomVariableStreamParetoAntitheticTestCase ()
+ParetoAntitheticTestCase::ParetoAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Pareto Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamParetoAntitheticTestCase::ChiSquaredTest (Ptr<ParetoRandomVariable> p)
+ParetoAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 1, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 1., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   double shape = 2.0;
   double scale = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_pareto_P (range[i + 1], shape, scale) - gsl_cdf_pareto_P (range[i], shape, scale);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, p->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamParetoAntitheticTestCase::DoRun (void)
+ParetoAntitheticTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<ParetoRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<ParetoRandomVariable> e = CreateObject<ParetoRandomVariable> ();
-
-      // Make this generate antithetic values.
-      e->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (e);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double shape = 2.0;
   double scale = 1.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<ParetoRandomVariable> x = CreateObject<ParetoRandomVariable> ();
@@ -1218,13 +1113,7 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean is given by
   //
@@ -1239,48 +1128,43 @@
   double expectedMean = (shape * scale) / (shape - 1.0);
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for Weibull distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamWeibullTestCase : public TestCase
+/**
+ * Test case for Weibull distribution random variable stream generator
+ */
+class WeibullTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+  // Constructor
+  WeibullTestCase ();
 
-  RandomVariableStreamWeibullTestCase ();
-  virtual ~RandomVariableStreamWeibullTestCase ();
-
-  double ChiSquaredTest (Ptr<WeibullRandomVariable> p);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamWeibullTestCase::RandomVariableStreamWeibullTestCase ()
-  : TestCase ("Weibull Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamWeibullTestCase::~RandomVariableStreamWeibullTestCase ()
+WeibullTestCase::WeibullTestCase ()
+  : TestCaseBase ("Weibull Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamWeibullTestCase::ChiSquaredTest (Ptr<WeibullRandomVariable> p)
+WeibullTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 1, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 1., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that p has shape equal to one and scale
   // equal to one, which are their default values for this
@@ -1288,61 +1172,32 @@
   double a = 1.0;
   double b = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_weibull_P (range[i + 1], a, b) - gsl_cdf_weibull_P (range[i], a, b);
       expected[i] *= N_MEASUREMENTS;
+      NS_LOG_INFO ("weibull: " << expected[i]);
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, p->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
 void
-RandomVariableStreamWeibullTestCase::DoRun (void)
+WeibullTestCase::DoRun (void)
 {
+  NS_LOG_FUNCTION (this);
   SetTestSuiteSeed ();
 
-  double sum = 0.;
+  auto generator = RngGenerator<WeibullRandomVariable> ();
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
   double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<WeibullRandomVariable> e = CreateObject<WeibullRandomVariable> ();
-      double result = ChiSquaredTest (e);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
-
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double scale = 5.0;
   double shape = 1.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<WeibullRandomVariable> x = CreateObject<WeibullRandomVariable> ();
@@ -1350,13 +1205,7 @@
   x->SetAttribute ("Shape", DoubleValue (shape));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // Weibull distributed random variable is
@@ -1383,48 +1232,43 @@
   double expectedMean = scale;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for antithetic Weibull distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamWeibullAntitheticTestCase : public TestCase
+/**
+ * Test case for antithetic Weibull distribution random variable stream generator
+ */
+class WeibullAntitheticTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
+  // Constructor
+  WeibullAntitheticTestCase ();
 
-  RandomVariableStreamWeibullAntitheticTestCase ();
-  virtual ~RandomVariableStreamWeibullAntitheticTestCase ();
-
-  double ChiSquaredTest (Ptr<WeibullRandomVariable> p);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamWeibullAntitheticTestCase::RandomVariableStreamWeibullAntitheticTestCase ()
-  : TestCase ("Antithetic Weibull Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {1e-2};  
+};
 
-RandomVariableStreamWeibullAntitheticTestCase::~RandomVariableStreamWeibullAntitheticTestCase ()
+WeibullAntitheticTestCase::WeibullAntitheticTestCase ()
+  : TestCaseBase ("Antithetic Weibull Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamWeibullAntitheticTestCase::ChiSquaredTest (Ptr<WeibullRandomVariable> p)
+WeibullAntitheticTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 1, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 1., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that p has shape equal to one and scale
   // equal to one, which are their default values for this
@@ -1432,65 +1276,31 @@
   double a = 1.0;
   double b = 1.0;
 
-  for (uint32_t i = 0; i < N_BINS; ++i)
+  for (std::size_t i = 0; i < N_BINS; ++i)
     {
       expected[i] = gsl_cdf_weibull_P (range[i + 1], a, b) - gsl_cdf_weibull_P (range[i], a, b);
       expected[i] *= N_MEASUREMENTS;
     }
 
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      gsl_histogram_increment (h, p->GetValue ());
-    }
-
-  double tmp[N_BINS];
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      tmp[i] = gsl_histogram_get (h, i);
-      tmp[i] -= expected[i];
-      tmp[i] *= tmp[i];
-      tmp[i] /= expected[i];
-    }
+  double chiSquared = ChiSquared (h, expected, rng);
 
   gsl_histogram_free (h);
-
-  double chiSquared = 0;
-
-  for (uint32_t i = 0; i < N_BINS; ++i)
-    {
-      chiSquared += tmp[i];
-    }
-
   return chiSquared;
 }
 
-void
-RandomVariableStreamWeibullAntitheticTestCase::DoRun (void)
-{
-  SetTestSuiteSeed ();
-
-  double sum = 0.;
-  double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
-
-  for (uint32_t i = 0; i < N_RUNS; ++i)
-    {
-      Ptr<WeibullRandomVariable> e = CreateObject<WeibullRandomVariable> ();
-
-      // Make this generate antithetic values.
-      e->SetAttribute ("Antithetic", BooleanValue (true));
-
-      double result = ChiSquaredTest (e);
-      sum += result;
-    }
-
-  sum /= (double)N_RUNS;
+void
+WeibullAntitheticTestCase::DoRun (void)
+{
+  NS_LOG_FUNCTION (this);
+  SetTestSuiteSeed ();
 
+  auto generator = RngGenerator<WeibullRandomVariable> (true);
+  double sum = ChiSquaredsAverage (&generator, N_RUNS);
+  double maxStatistic = gsl_cdf_chisq_Qinv (0.05, N_BINS);
   NS_TEST_ASSERT_MSG_LT (sum, maxStatistic, "Chi-squared statistic out of range");
 
   double scale = 5.0;
   double shape = 1.0;
-  double value;
 
   // Create the RNG with the specified range.
   Ptr<WeibullRandomVariable> x = CreateObject<WeibullRandomVariable> ();
@@ -1501,13 +1311,7 @@
   x->SetAttribute ("Antithetic", BooleanValue (true));
 
   // Calculate the mean of these values.
-  sum = 0.0;
-  for (uint32_t i = 0; i < N_MEASUREMENTS; ++i)
-    {
-      value = x->GetValue ();
-      sum += value;
-    }
-  double valueMean = sum / N_MEASUREMENTS;
+  double valueMean = Average (x);
 
   // The expected value for the mean of the values returned by a
   // Weibull distributed random variable is
@@ -1534,48 +1338,43 @@
   double expectedMean = scale;
 
   // Test that values have approximately the right mean value.
-  double TOLERANCE = expectedMean * 1e-2;
-  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, TOLERANCE, "Wrong mean value.");
+  NS_TEST_ASSERT_MSG_EQ_TOL (valueMean, expectedMean, expectedMean * TOLERANCE, "Wrong mean value.");
 }
 
-// ===========================================================================
-// Test case for log-normal distribution random variable stream generator
-// ===========================================================================
-class RandomVariableStreamLogNormalTestCase : public TestCase
+/**
+ * Test case for log-normal distribution random variable stream generator
+ */
+class LogNormalTestCase : public TestCaseBase
 {
 public:
-  static const uint32_t N_RUNS = 5;
-  static const uint32_t N_BINS = 50;
-  static const uint32_t N_MEASUREMENTS = 1000000;
-
-  RandomVariableStreamLogNormalTestCase ();
-  virtual ~RandomVariableStreamLogNormalTestCase ();
+  // Constructor
+  LogNormalTestCase ();
 
-  double ChiSquaredTest (Ptr<LogNormalRandomVariable> n);
+  // Inherited
+  double ChiSquaredTest (Ptr<RandomVariableStream> rng) const;
 
 private:
+  // Inherited
   virtual void DoRun (void);
-};
 
-RandomVariableStreamLogNormalTestCase::RandomVariableStreamLogNormalTestCase ()
-  : TestCase ("Log-Normal Random Variable Stream Generator")
-{}
+  /**
+   * Tolerance for testing rng values against expectation,
+   * as a fraction of mean value.
+   */
+  static constexpr double TOLERANCE {3e-2};  
+};
 
-RandomVariableStreamLogNormalTestCase::~RandomVariableStreamLogNormalTestCase ()
+LogNormalTestCase::LogNormalTestCase ()
+  : TestCaseBase ("Log-Normal Random Variable Stream Generator")
 {}
 
 double
-RandomVariableStreamLogNormalTestCase::ChiSquaredTest (Ptr<LogNormalRandomVariable> n)
+LogNormalTestCase::ChiSquaredTest (Ptr<RandomVariableStream> rng) const
 {
   gsl_histogram * h = gsl_histogram_alloc (N_BINS);
+  auto range = UniformHistogramBins (h, 0, 10, false);
 
-  double range[N_BINS + 1];
-  FillHistoRangeUniformly (range, N_BINS + 1, 0., 10.);
-  range[N_BINS] = std::numeric_limits<double>::max ();
-
-  gsl_histogram_set_ranges (h, range, N_BINS + 1);
-
-  double expected[N_BINS];
+  std::vector<double> expected (N_BINS);
 
   // Note that this assumes that n has mu equal to zero and sigma
   // equal to one, which are their default values for this
